<?php
$blog = 1;
$doing_rss = 1;
require('wp-blog-header.php');
header('Content-type: text/xml; charset=' . get_settings('blog_charset'),true);


if (!isset($rss_language)) { $rss_language = 'en'; }
if (!isset($rss_encoded_html)) { $rss_encoded_html = 0; }
if (!isset($rss_excerpt_length) || ($rss_encoded_html == 1)) { $rss_excerpt_length = 0; }
?>
<?php echo '<?xml version="1.0" '. ' encoding="'.get_settings('blog_charset').'"?>'; ?>
<!-- generator="wordpress/<?php echo $wp_version ?>" -->
<rss version="2.0"
    xmlns:content="http://purl.org/rss/1.0/modules/content/">

<channel>
    <title><?php bloginfo_rss('name') ?> &#187; Recent Links</title>
    <link><?php rpmod_recentlinks_archives_url(); ?></link>
    <description>12 most recent links.</description>
    <language><?php echo $rss_language ?></language>
    <pubDate><?php echo gmdate('r'); ?></pubDate>
    <generator>http://wordpress.org/?v=<?php echo $wp_version ?></generator>

<?php
    $limit = 12;
    $tablerecentlinks = $table_prefix.'recentlinks';
    $time_difference = get_settings('time_difference');
    $now = date('Y-m-d H:i:s',(time() + ($time_difference * 3600)));
    if ('' != $limit) {
        $limit = (int) $limit;
        $limit = " LIMIT $limit";
    }
    $sql = "SELECT ID, link_url, link_text, link_caption, link_rel, link_target, link_visible, date_added FROM $tablerecentlinks WHERE date_added < '$now' AND link_visible = 'Y' ORDER BY date_added DESC $limit";

    $links = $wpdb->get_results($sql);

    $siteurl = get_settings('siteurl');
    $rewrite = get_settings('permalink_structure');
    foreach ($links as $link) {
        $link->link_text = stripslashes($link->link_text);
        $link->link_url = stripslashes($link->link_url);
        $link->link_caption = stripslashes($link->link_caption);
        $link->link_rel = stripslashes($link->link_rel);
        $link->link_target = stripslashes($link->link_target);


        $title_rss = str_replace('[a]', '', convert_chars(strip_tags($link->link_text), 'unicode'));
        $title_rss = str_replace('[/a]', '', $title_rss);
        if (strlen($link->link_caption) == 0) {
            $desc_rss = 'There is no caption for this link.';
        } else {
            $desc_rss = $link->link_caption;
        }
        $desc_rss = convert_chars($desc_rss, 'unicode');


        if (strlen($rewrite) > 0) { // using mod_rewrite
            $permalink_url = $siteurl.'/recent-links/'.date('Y/m', strtotime($link->date_added)).'/#rlink-'.$link->ID;
        } else {
            $permalink_url = $siteurl.'/wp-recent-links.php?y='.date('Y', strtotime($link->date_added)).'&amp;m='.date('m', strtotime($link->date_added)).'#rlink-'.$link->ID;
        }



        echo '<item>'."\n";
        echo '<title>'.$title_rss.'</title>'."\n";
        echo '<description>'.$desc_rss.'</description>'."\n";
        echo '<pubDate>'.gmdate('r', strtotime($link->date_added)).'</pubDate>'."\n";
        echo '<guid isPermaLink="true">'.$permalink_url.'</guid>'."\n";



        $a_tag = '[a]';
        $a_tag2 = '[/a]';
        $before = '';
        $after = '';
        $between = '';
        $date_append = 'F j';
        $this_date = date($date_append, strtotime($link->date_added));

        if (strlen($link->link_caption) > 0) {
            $link->link_caption = str_replace($a_tag, '', strip_tags($link->link_text));
            $link->link_caption = str_replace($a_tag2, '', $link->link_caption);
            $raw_caption = $link->link_caption;
            $link->link_caption = ' | '.$link->link_caption;
        } else {
            $link->link_caption = '';

        }
        if (strlen($link->link_rel) == 0) {
            $rel = '';
        } else {
            $rel = ' rel="'.$link->link_rel.'"';
        }
        if (strlen($link->link_target) == 0) {
            $target = '';
        } else {
            $target = ' target="'.$link->link_target.'"';
        }

        if (  is_int(strpos($link->link_url, '&'))  &&  !strpos($link->link_url, '&amp;')  &&  !strpos($link->link_url, '&#038;')  ) {
            $link->link_url = str_replace('&', '&amp;', $link->link_url);
        }

        if (  is_int(strpos($link->link_text, $a_tag))  &&  is_int(strpos($link->link_text, $a_tag2))  ) {
            $pos_open = strpos($link->link_text, $a_tag);
            $pos_close = strpos($link->link_text, $a_tag2, $pos_open);

            $prefix = substr($link->link_text, 0, $pos_open);
            $suffix = substr($link->link_text, $pos_close + strlen($a_tag2));

            $middle = substr($link->link_text, $pos_open + strlen($a_tag), $pos_close - ($pos_open + strlen($a_tag)));

            $new_link = $prefix.'<a href="'.$link->link_url.'" title="'.wptexturize(date($date_append, strtotime($link->date_added)).$link->link_caption).'"'.$rel.$target.'>'.wptexturize($middle).'</a>'.$suffix;
        } else {
            $new_link = '<a href="'.$link->link_url.'" title="'.wptexturize(date($date_append, strtotime($link->date_added)).$link->link_caption).'"'.$rel.$target.'>'.wptexturize($link->link_text).'</a>';
        }



        echo '<content:encoded><![CDATA['.$new_link.' - '.$desc_rss.']]></content:encoded>'."\n";
        echo '</item>'."\n"."\n";
    }

?>
</channel>
</rss>